# Rokwire Code of Conduct

The Rokwire Code of Conduct outlines expectations of participant behaviors and responsibilities within the Rokwire open source community, as well as steps to reporting unacceptable behavior. This code is not exhaustive or complete. It distills our common understanding of a collaborative, shared environment, and our goals. We expect it to be followed in spirit as much as in the letter.

Our code both protects the integrity of the Rokwire community and establishes boundaries to ensure an inclusive, ethical culture. We are committed to providing a welcoming and inspiring community for all. The expected behaviors described in this code of conduct are communicated, monitored, and administered by the Rokwire open source community, with escalation through the Rokwire Open Source Community Manager.

The Rokwire open source community is:

- **Welcoming.** We strive to be a community that welcomes and supports people of all backgrounds and identities. This includes, but is not limited to members of any race, ethnicity, culture, national origin, color, immigration status, social and economic class, educational level, sex, sexual orientation, gender identity and expression, age, size, family status, political belief, religion, and mental and physical ability.
- **Friendly and Patient.** You might not be communicating with someone in their primary spoken or programming language, and others may not have your level of understanding.
- **Considerate.** Your work is used by others, and you depend on the work of others. Your decisions affect users and colleagues, so be sure to take those consequences into account.
- **Careful and Kind in the Words We Choose.** We are a community of professionals and we conduct ourselves professionally. We do not insult or put down others. Harassment and other exclusionary behavior are not acceptable. This includes, but is not limited to: 
  - Violent threats or language
  - Discriminatory or derogatory jokes and language
  - Posting sexually explicit or violent material
  - Posting, or threatening to post, people's personally identifying information ("doxing")
  - Insults, especially those using discriminatory terms or slurs
  - Behavior that could be perceived as sexual attention
  - Advocating for or encouraging any of the above behaviors
- **Respectfully Curious about Why We Disagree.** Disagreements, both social and technical, happen all the time. Being unable to understand why someone holds a viewpoint doesn’t mean that they’re wrong. We might all experience some frustration now and then, but we do not allow that frustration to turn into a personal attack. We resolve disagreements and differing views constructively instead of blaming each other. Our focus is learning from our mistakes and helping to resolve issues together. The strength of our community comes from its diversity, and a community cannot be productive when people feel uncomfortable or threatened.
## Reporting Code of Conduct Issues
If you experience or witness unacceptable behavior—or have any other concerns—please report it by contacting us via rokwire@illinois.edu. In your report please include:

  - Your contact information.
  - Names (real, usernames or pseudonyms) of any individuals involved. If there are additional witnesses, please include them as well.
  - Your account of what occurred, and if you believe the incident is ongoing. If there is a publicly available record (e.g. a mailing list archive or a public chat log), please include a link or attachment.
  - Any additional information that may be helpful.

All reports will be reviewed by a multi-person team and will result in a response that is considered necessary and appropriate to the circumstances. Where additional perspectives are needed, the team may seek insight from others with relevant expertise or experience. The confidentiality of the person reporting the incident will be kept at all times. Involved parties are never part of the review team. Further details of specific policies regarding implementing the code of conduct may be posted separately.

Project maintainers are expected to follow and administer the code of conduct in good faith. Those who refuse to do so may face temporary or permanent repercussions as determined by members of the project's leadership. Anyone asked to stop unacceptable behavior is expected to comply immediately. If an individual engages in unacceptable behavior, the project’s leadership may take any action they deem appropriate, up to and including a permanent ban from our community without warning.

## Attribution & Acknowledgements
This code of conduct is based on the template established by the [TODO Group](https://todogroup.org/), the [Microsoft Open Source Code of Conduct](https://opensource.microsoft.com/codeofconduct/), and the [Twitter Open Source Code of Conduct](https://github.com/twitter/code-of-conduct/blob/a4d2e558dc730ba440b2ce95cf87f023c9f3fd3d/code-of-conduct.md).
